<template>
  <div class="hello" style="padding: 20px">
    <h1>Car Management</h1>
    <div style="display: inline">
      <b-button
        :variant="typeOfBtn"
        class="btn-add"
        @click="add()"
        style="padding-left: 25px; padding-right: 25px"
        :disabled="btnAdd"
        >Add New</b-button
      >
    </div>

    <div>
      <transition name="fade" mode="out-in">
        <div v-if="show">
          <b-card bg-variant="light">
            <b-form>
              <center>
                <h4>{{ editAddText }}</h4>
                <p />
                <table>
                  <tr>
                    <td>
                      <b-form-group
                        id="form-group-name"
                        label="Name :"
                        label-for="name"
                        label-cols-sm="3"
                        label-align-sm="right"
                        valid-feedback="⠀"
                        invalid-feedback="Name must more than 1"
                        :state="validateName"
                      >
                        <b-form-input
                          type="text"
                          id="name"
                          v-model="form.name"
                          :state="validateName"
                          @keypress="isLetter($event)"
                          autofocus
                        />
                        <div
                          style="
                            font-size: 0.875em;
                            margin-top: 0.25rem;
                            width: 100%;
                          "
                          :hidden="hideName"
                        >
                          ⠀
                        </div>
                      </b-form-group>
                    </td>
                    <td>
                      <b-form-group
                        id="form-group-model"
                        label="Model :"
                        label-for="model"
                        label-cols-sm="3"
                        label-align-sm="right"
                        valid-feedback="⠀"
                        invalid-feedback="Model must more than 1"
                        :state="validateModel"
                      >
                        <b-form-input
                          type="text"
                          id="model"
                          v-model="form.model"
                          :state="validateModel"
                          @keypress="isLetter($event)"
                        />
                        <div
                          style="
                            font-size: 0.875em;
                            margin-top: 0.25rem;
                            width: 100%;
                          "
                          :hidden="hideModel"
                        >
                          ⠀
                        </div>
                      </b-form-group>
                    </td>
                    <td>
                      <b-form-group
                        id="form-group-price"
                        label="Price :"
                        label-for="price"
                        label-cols-sm="3"
                        label-align-sm="right"
                        valid-feedback="⠀"
                        invalid-feedback="Price must higher than 1"
                        :state="validatePrice"
                      >
                        <b-form-input
                          type="number"
                          id="price"
                          v-model="form.price"
                          :state="validatePrice"
                          @keypress="isLetterNum($event)"
                        />
                        <div
                          style="
                            font-size: 0.875em;
                            margin-top: 0.25rem;
                            width: 100%;
                          "
                          :hidden="hidePrice"
                        >
                          ⠀
                        </div>
                      </b-form-group>
                    </td>
                    <td>
                      <b-form-group
                        id="form-group-color"
                        label="Color :"
                        label-for="color"
                        label-cols-sm="3"
                        label-align-sm="right"
                        valid-feedback="⠀"
                        invalid-feedback="Color must more than 3"
                        :state="validateColor"
                      >
                        <b-form-input
                          type="text"
                          id="color"
                          v-model="form.color"
                          :state="validateColor"
                          @keypress="isLetter($event)"
                        />
                        <div
                          style="
                            font-size: 0.875em;
                            margin-top: 0.25rem;
                            width: 100%;
                          "
                          :hidden="hideColor"
                        >
                          ⠀
                        </div>
                      </b-form-group>
                    </td>
                  </tr>
                  <tr>
                    <td>
                      <b-form-group
                        id="form-group-NumberOfSeat"
                        label="Seat :"
                        label-for="seat"
                        label-cols-sm="3"
                        label-align-sm="right"
                        valid-feedback="⠀"
                        invalid-feedback="Seat must more than 1"
                        :state="validateSeat"
                        class="inputbox"
                      >
                        <b-form-input
                          type="number"
                          id="seat"
                          v-model="form.numberOfSeat"
                          :state="validateSeat"
                          @keypress="isLetterNum($event)"
                        />
                        <div
                          style="
                            font-size: 0.875em;
                            margin-top: 0.25rem;
                            width: 100%;
                          "
                          :hidden="hideSeat"
                        >
                          ⠀
                        </div>
                      </b-form-group>
                    </td>
                    <td>
                      <b-form-group
                        id="form-group-type"
                        label="Type :"
                        label-for="type"
                        label-cols-sm="3"
                        label-align-sm="right"
                        valid-feedback="⠀"
                        invalid-feedback="Type must be selected"
                        :state="validateType"
                        class="inputbox"
                      >
                        <b-form-select
                          v-model="form.type"
                          :state="validateType"
                          @keypress="isLetter($event)"
                        >
                          <option value="" selected disabled hidden>
                            Choose here
                          </option>
                          <option
                            v-for="(typeCar, idx) in typeOfCar"
                            :key="idx"
                            :value="typeCar"
                            value-field="form.type"
                            text-field="form.type"
                            selected="selected"
                          >
                            {{ typeCar }}
                          </option>
                        </b-form-select>
                        <div
                          style="
                            font-size: 0.875em;
                            margin-top: 0.25rem;
                            width: 100%;
                          "
                          :hidden="hideType"
                        >
                          ⠀
                        </div>
                      </b-form-group>
                    </td>
                    <td>
                      <b-form-group
                        id="form-group-brand"
                        label="Brand :"
                        label-for="brand"
                        label-cols-sm="3"
                        label-align-sm="right"
                        valid-feedback="⠀"
                        invalid-feedback="Brand must more than 1"
                        :state="validateBrand"
                        class="inputbox"
                      >
                        <b-form-input
                          type="text"
                          id="brand"
                          v-model="form.brand"
                          :state="validateBrand"
                          @keypress="isLetter($event)"
                        />
                        <div
                          style="
                            font-size: 0.875em;
                            margin-top: 0.25rem;
                            width: 100%;
                          "
                          :hidden="hideBrand"
                        >
                          ⠀
                        </div>
                      </b-form-group>
                    </td>
                    <td>
                      <b-form-group
                        class="inputbox"
                        id="form-group-country"
                        label="Country :"
                        label-for="country"
                        label-cols-sm="3"
                        label-align-sm="right"
                        valid-feedback="⠀"
                        invalid-feedback="Country must more than 1"
                        :state="validateCountry"
                      >
                        <b-form-input
                          type="text"
                          id="country"
                          v-model="form.country"
                          :state="validateCountry"
                          @keypress="isLetter($event)"
                        />
                        <div
                          style="
                            font-size: 0.875em;
                            margin-top: 0.25rem;
                            width: 100%;
                          "
                          :hidden="hideCountry"
                        >
                          ⠀
                        </div>
                      </b-form-group>
                    </td>
                  </tr>
                  <tr>
                    <td>
                      <b-button
                        :disabled="!validateForm"
                        variant="success"
                        @click="submit()"
                        style="width: 100px"
                        >Save</b-button
                      >&emsp;
                      <b-button
                        variant="danger"
                        @click="closeForm()"
                        style="width: 100px"
                        >Cancel</b-button
                      >
                    </td>
                  </tr>
                </table>
              </center>
            </b-form>
          </b-card>
        </div>
      </transition>
    </div>
    <b-input-group class="mt-3" style="padding-left: 70%">
      <b-form-input v-model="searchString"></b-form-input>
      <b-input-group-append>
        <b-button variant="info" @click="getall()">Search</b-button>
      </b-input-group-append>
    </b-input-group>
    <p />
    <b-table
      responsive
      striped
      hover
      show-empty
      :items="cars"
      :fields="fields"
      :current-page="currentPage"
      :per-page="10"
      class="mt-3"
      id="carTable"
    >
      <template #cell(option)="{ item }">
        <b-button
          variant="warning"
          @click="enableEdit(item)"
          :disabled="btnEdit"
          >Edit</b-button
        >
        &emsp;
        <b-button variant="danger" @click="deleteCar(item)">Delete</b-button>
      </template>
      <template #empty>
        <div align="center">
          <label>ไม่พบข้อมูล</label>
        </div>
      </template>
    </b-table>
    <!-- <center v-if="!noData">
      <p style="font-size: 1cm">No data</p>
    </center> -->

    <b-pagination
      v-model="currentPage"
      :total-rows="rows"
      :per-page="10"
      aria-controls="carTable"
    ></b-pagination>
  </div>
</template>

<script>
import { isLetterNum } from "../utils/inputRegxUtil";
import { isLetterCha } from "../utils/inputRegxUtil";
import { isLetter } from "../utils/inputRegxUtil";

export default {
  data() {
    return {
      btnEdit: false,
      btnAdd: false,
      searchString: "",
      cars: [],
      fields: [
        { key: "id", label: "ID", sortable: true },
        { key: "name", label: "Name", sortable: true },
        { key: "model", label: "Model", sortable: true },
        { key: "price", label: "Price (Baht)", sortable: true },
        { key: "color", label: "Color", sortable: true },
        { key: "numberOfSeat", label: "Seat", sortable: true },
        { key: "type", label: "Type", sortable: true },
        { key: "brand", label: "Brand", sortable: true },
        { key: "country", label: "Country", sortable: true },
        { key: "option", label: "Option", sortable: false },
      ],
      currentPage: 1,
      show: false,
      form: {
        id: "",
        name: "",
        model: "",
        price: 0.0,
        color: "",
        numberOfSeat: 0,
        type: "",
        brand: "",
        country: "",
      },
      typeOfCar: [
        "Sedan",
        "Coupe",
        "Sport",
        "SUV",
        "Pickup Truck",
        "Hatchaback",
        "Convertible",
        "Micro",
        "Universal",
        "Liftback",
        "Cabriolet",
        "Roadster",
        "Targe",
        "Limousine",
        "Muscle car",
        "Super car",
        "Crossover",
      ],
      typeOfBtn: "success",
      // api: "",
      editAddText: "Add",
      // number: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "."],
      keyPressed: "",
      hideCountry: false,
      hideBrand: false,
      hideName: false,
      hidePrice: false,
      hideModel: false,
      hideType: false,
      hideSeat: false,
      hideColor: false,
    };
  },
  computed: {
    validateName() {
      if (this.form.name.length == 0) {
        this.showSpace("name");
        return null;
      } else {
        this.hideSpace("name");
        return this.form.name.length > 1 && this.form.name.trim() != ""; //input won't green by space bar
      }
    },
    validateColor() {
      if (this.form.color.length == 0) {
        this.showSpace("color");
        return null;
      } else {
        this.hideSpace("color");
        return this.form.color.length >= 3 && this.form.color.trim() != "";
      }
    },
    validateBrand() {
      if (this.form.brand.length == 0) {
        this.showSpace("brand");
        return null;
      } else {
        this.hideSpace("brand");
        return this.form.brand.length > 1 && this.form.brand.trim() != "";
      }
    },
    validateCountry() {
      if (this.form.country.length == 0) {
        this.showSpace("country");
        return null;
      } else {
        this.hideSpace("country");
        return this.form.country.length >= 2 && this.form.country.trim() != "";
      }
    },
    validateModel() {
      if (this.form.model.length == 0) {
        this.showSpace("model");
        return null;
      } else {
        this.hideSpace("model");
        return this.form.model.length > 1 && this.form.model.trim() != "";
      }
    },
    validateSeat() {
      if (this.form.numberOfSeat == 0) {
        this.showSpace("seat");
        return null;
      } else {
        this.hideSpace("seat");
        return this.form.numberOfSeat !== "" && this.form.numberOfSeat > 0;
      }
    },
    validateType() {
      if (this.form.type.length == 0) {
        this.showSpace("type");
        return null;
      } else {
        this.hideSpace("type");
        return this.form.type !== "";
      }
    },
    validatePrice() {
      if (this.form.price == 0) {
        this.showSpace("price");
        return null;
      } else {
        this.hideSpace("price");
        return this.form.price !== "" && this.form.price > 0;
      }
    },
    validateForm() {
      return (
        this.validateCountry &&
        this.validateModel &&
        this.validateSeat &&
        this.validatePrice &&
        this.validateName &&
        this.validateColor &&
        this.validateBrand && 
        this.validateType
      );
    },
    noData() {
      return this.cars.length > 0;
    },
    rows() {
      return this.cars.length;
    },
  },
  methods: {
    isLetterNum,
		isLetterCha,
		isLetter,

    hideSpace(type) {
      if (type == "country") {
        this.hideCountry = true;
      }
      if (type == "brand") {
        this.hideBrand = true;
      }
      if (type == "name") {
        this.hideName = true;
      }
      if (type == "price") {
        this.hidePrice = true;
      }
      if (type == "model") {
        this.hideModel = true;
      }
      if (type == "type") {
        this.hideType = true;
      }
      if (type == "seat") {
        this.hideSeat = true;
      }
      if (type == "color") {
        this.hideColor = true;
      }
    },
    showSpace(type) {
      if (type == "country") {
        this.hideCountry = false;
      }
      if (type == "brand") {
        this.hideBrand = false;
      }
      if (type == "name") {
        this.hideName = false;
      }
      if (type == "price") {
        this.hidePrice = false;
      }
      if (type == "model") {
        this.hideModel = false;
      }
      if (type == "type") {
        this.hideType = false;
      }
      if (type == "seat") {
        this.hideSeat = false;
      }
      if (type == "color") {
        this.hideColor = false;
      }
    },
    add() {
      this.btnEdit = true;
      this.openForm();
    },
    openForm() {
      this.show = true;
      this.resetForm();
      this.editAddText = "Add New";
      this.typeOfBtn = "warning";
    },
    closeForm() {
      this.resetForm();
      this.show = false;
      this.typeOfBtn = "success";
      this.btnEdit = false;
      this.btnAdd = false;
    },
    enableEdit(item) {
      this.openForm();
      this.btnAdd = true;
      this.editAddText = "Editing";
      this.form.id = item.id;
      this.form.name = item.name;
      this.form.model = item.model;
      this.form.price = item.price;
      this.form.color = item.color;
      this.form.numberOfSeat = item.numberOfSeat;
      this.form.type = item.type;
      this.form.brand = item.brand;
      this.form.country = item.country;
    },
    async getall() {
      if (this.searchString == "") {
        let { error, result } = await this.$api.CarDetail.getCars();
        if (result !== null) {
          this.cars = result.reverse();
        } else if (error !== null) {
          console.log(error);
        }
      } else {
        let { error, result } = await this.$api.CarDetail.searchCars(
          this.searchString
        );
        if (result !== null) {
          this.cars = result.reverse();
        } else if (error !== null) {
          console.log(error);
        }
      }
    },
    async deleteCar(item) {
      if (this.form.id != item.id) {
        if (confirm("Do you want to delete " + item.name + " ?")) {
          let { error, result } = await this.$api.CarDetail.deleteCars(item.id);
          if (result !== null) {
            this.toast("Deleted Data '" + item.name + "'.");
            this.getall();
          } else if (error !== null) {
            console.log(error);
          }
        }
      } else {
        this.toast("Fail : This Data is Editing can not delete");
      }
    },
    resetForm() {
      this.form = {
        id: "",
        name: "",
        model: "",
        price: 0.0,
        color: "",
        numberOfSeat: 0,
        type: "",
        brand: "",
        country: "",
      };
    },
    submit() {
      this.form.price = parseFloat(this.form.price);
      const car = JSON.parse(JSON.stringify(this.form));
      if (this.form.id === "") {
        // add new
        this.addData(car);
      } else {
        // Edit
        this.editData(car);
      }
    },
    async addData(car) {
      let { error, result } = await this.$api.CarDetail.addCars(car);
      if (result !== null) {
        if (result == true) {
          this.toast("Added Data '" + car.name + "'.");
          this.closeForm();
          this.getall();
        } else {
          this.toast(
            "Fail : The value is empty or there are spacial characters in form."
          );
        }
      } else if (error !== null) {
        console.log(error);
      }
    },
    async editData(car) {
      let { error, result } = await this.$api.CarDetail.editCars(car);
      if (result !== null) {
        if (result == true) {
          this.toast("Edited Data '" + car.name + "'.");
          this.closeForm();
          this.getall();
        } else {
          this.toast(
            "Fail : The value is empty or there are spacial characters in form."
          );
        }
      } else if (error !== null) {
        console.log(error);
      }
    },
    toast(msg) {
      this.$bvToast.toast(msg, {
        title: "Alert Messege",
        toaster: "b-toaster-top-center",
        solid: true,
      });
    },
   
  },
  mounted() {
    this.getall();
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.btn-add {
  position: absolute;
  right: 20px;
  top: 90px;
}
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s;
}
.fade-enter, .fade-leave-to /* .fade-leave-active in <2.1.8 */ {
  opacity: 0;
}

.inputbox {
  width: 35ch;
}
</style>
